///////////////////////////////////////////////////////////////////////////////////////
//NAME:     MFC Rev3 Board Test Configuration
//DATE:     08-04-09
//PURPOSE:  Configure the clockchip and ADC , SDRAM Test
//
////////////////////////////////////////////////////////////////////////////////////////
#include <def21369.h>
#include <asm_sprt.h>
#include "cogging.h"

.extern assem_stack_bottom,assem_stack_length,assem_stack_top;
.global _init_ASM, _init_ASM_Stack;

//  External Memory

.section /NO_INIT / dm seg_sdram;

.var sdram_buf[SDRAM_BUFSIZE];

.section /NO_INIT / dm seg_flash;

.var flash_buf[FLASH_BUFSIZE];

.section /NO_INIT / dm seg_max2;

.var max2_buf[MAX2_BUFSIZE];

.section /NO_INIT / dm seg_fpga;

.var fpga_buf[FPGA_BUFSIZE];


.section/pm seg_pmco;

_init_ASM:
leaf_entry;
//-----------------------------------------------------------------------------------------
// Setup the interrupts IRQ0 (Max2 interrupts) IRQ1 (Start Trigger) and SFT0I (Data Acquire)

// Enable IRQ0 (Max2 interrupts) and IRQ1 (external interrupt, TCLK)
	ustat3 = dm(SYSCTL);
	bit set ustat3 IRQ0EN|IRQ1EN;  // allocate pins for FLAG0 and FLAG1 as interrupt inputs
	dm(SYSCTL) = ustat3;
	bit set mode2 IRQ0E|IRQ1E;  // edge-sensitive (if set, = 1) or level-sensitive (if cleared, = 0)

	bit clr irptl IRQ0I|IRQ1I; // clear any latched occurances of the interrupts
	bit set imask IRQ0I|IRQ1I;   // unmask (enable if set, = 1), or mask (disable if cleared, = 0) the interrupts

// Enable SFT0I (Data_Aquire)
	bit clr irptl SFT0I;
	bit set imask SFT0I;
	
// Turn on the Global Interrupt Enable
	bit set mode1 IRPTEN;  // Enables (if set, = 1) or disables (if cleared, = 0) all maskable interrupts

//------------------------------------------------------------------------------------------
// Set up Flags 4 thru 10 as inputs or outputs and initialize the outputs
// Note: The outputs do  not drive any pins until they are associated with
//       a DPI external pin and enabled.  Before a DPI pin is enabled it is
//       pulled-up through an internal 22.5 kohm resistor (see DPI_PIN_PULLUP register
//       in the ADSP-21368 Hardware Reference Manual).
//
// FLAGS:
// {FLG4, FLG5, FLG6} [inputs] => signal DSP_IRQ_MUX(0...2) and are inputs from the MAX II
//  FLG7  [output] => signal SHARCDPI10 (acquisition trigger to FPGA)
//  FLG8  [input]  => signal SHARCDPI11 (acquisition status from FPGA)
//  FLG9  [output] => signal DSP-MAXII_SPARE0 (DSP_Run_Flag signal to MAX II)
//  FLG10 [output] => signal DSP_BREQ (DSP is bus master = 1, MAX II is bus master = 0)

//  Note: All DPI pin signals are pulled up HIGH at DSP RESET by 22.5 kohms.  This is
//        the state at least until the FLAG is assigned to a DPI pin buffer and the
//        pin is enabled.

//Set Flag 4,5,6 (IRQ_MUX0,1,2) and 8 (FPGA_DAQ_Status) as inputs (default at reset)
//Set Flag 7 (FPGA_DAQ_Trigger), Set Flag 9 (DSP_MAX2_Spare0) and Flag 10 (DSP_BREQ) as outputs
	bit set FLAGS FLG7O|FLG9O|FLG10O;
	bit clr FLAGS FLG7;			//clear trigger to FPGA,
	bit set FLAGS FLG9;			//FLG9 = 1 ,disables configuration of FPGA **CORRECTED COMMENT 8/29/2012
	bit set FLAGS FLG10;		//FLG10 = 1 ,DSP is Bus Master 

//Test SDRAM Write
	nop; nop; nop;
	r13 = dm(0x00200000); //This initiates the power on sequence of SDRAM
	nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;
	nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;nop;


	r0 = 0xABCDEF12;
	dm(sdram_buf) = r0;
	r0 = 0x87654321;
	dm(sdram_buf+1) = r0;

leaf_exit;    
_init_ASM.end:


_init_ASM_Stack:
leaf_entry;

    bit set mode1 SRCU|SRD1H|SRD2H|SRD1L|SRD2L|SRRFH|SRRFL; // switch context to secondary registers 
    nop;
    b7 = assem_stack_bottom;      // use ldf file symbols
    l7 = assem_stack_length;
    i7 = assem_stack_top;
    bit clr mode1 SRCU|SRD1H|SRD2H|SRD1L|SRD2L|SRRFH|SRRFL; // switch context to primary registers 
    nop;
    nop;

leaf_exit;    
_init_ASM_Stack.end:

