// The following definition allows the SRU macro to check for errors. Once the routings have
// been verified, this definition can be removed to save some program memory space.
// The preprocessor will issue a warning stating this when using the SRU macro without this
// definition
#define SRUDEBUG  // Check SRU Routings for errors.
#include <SRU.h>
#include <sru21369.h>

void initDAI(void)
	{

// SPORT0 is a receiver from the FPGA
SRU(DAI_PB01_O,SPORT0_DA_I); // connect the DAI pin buffer 1 output signal to the SPORT0_DA
SRU(LOW,PBEN01_I);       // configures DAI pin1 as input
SRU(DAI_PB02_O,SPORT0_DB_I); // connect the DAI pin buffer 2 output signal to the SPORT0_DB
SRU(LOW,PBEN02_I);       // configures DAI pin2 as input
SRU(DAI_PB03_O,SPORT0_CLK_I);// connect the DAI pin buffer 3 output signal to the SPORT0_CLK
SRU(LOW,PBEN03_I);       // configures DAI pin1 as input
SRU(DAI_PB04_O,SPORT0_FS_I); // connect the DAI pin buffer 4 output signal to the SPORT0_FS
SRU(LOW,PBEN04_I);		 // configures DAI pin4 as input


// SPORT1 is a transmitter to the Front Panel DSP serial port
SRU(SPORT1_FS_O,DAI_PB05_I); // connect the SPORT1_FS to the DAI pin buffer 5 input signal  
SRU(HIGH,PBEN05_I);		 // configures DAI pin5 as an output
SRU(SPORT1_CLK_O,DAI_PB06_I);// connect the SPORT1_CLK to the DAI pin buffer 6 input signal  
SRU(HIGH,PBEN06_I);		 // configures DAI pin6 as an output
SRU(SPORT1_DB_O,DAI_PB07_I); // connect the SPORT1_DB to the DAI pin buffer 7 input signal  
SRU(HIGH,PBEN07_I);		 // configures DAI pin7 as an output
SRU(SPORT1_DA_O,DAI_PB08_I); // connect the SPORT1_DA to the DAI pin buffer 8 input signal  
SRU(HIGH,PBEN08_I);		 // configures DAI pin8 as an output

// SPORT2 is a receiver from the FPGA
SRU(DAI_PB09_O,SPORT2_DA_I); // connect the DAI pin buffer 9 output signal to the SPORT2_DA
SRU(LOW,PBEN09_I);       // configures DAI pin9 as input
SRU(DAI_PB10_O,SPORT2_DB_I); // connect the DAI pin buffer 10 output signal to the SPORT2_DB
SRU(LOW,PBEN10_I);       // configures DAI pin10 as input
SRU(DAI_PB11_O,SPORT2_CLK_I);// connect the DAI pin buffer 11 output signal to the SPORT2_CLK
SRU(LOW,PBEN11_I);       // configures DAI pin11 as input
SRU(DAI_PB12_O,SPORT2_FS_I); // connect the DAI pin buffer 12 output signal to the SPORT2_FS
SRU(LOW,PBEN12_I);		 // configures DAI pin12 as input
/*
//SPORT3 is a receiver from the Back Plane
SRU(DAI_PB13_O,SPORT3_DB_I); // connect the DAI pin buffer 13 output signal to the SPORT3_DB
SRU(LOW,PBEN13_I);       // configures DAI pin13 as input
SRU(DAI_PB14_O,SPORT3_DA_I); // connect the DAI pin buffer 14 output signal to the SPORT3_DA
SRU(LOW,PBEN14_I);       // configures DAI pin14 as input
SRU(DAI_PB15_O,SPORT3_CLK_I);// connect the DAI pin buffer 15 output signal to the SPORT3_CLK
SRU(LOW,PBEN15_I);       // configures DAI pin15 as input
SRU(DAI_PB16_O,SPORT3_FS_I); // connect the DAI pin buffer 16 output signal to the SPORT3_FS
SRU(LOW,PBEN16_I);       // configures DAI pin16 as input
*/
// SPORT3 is a transmitter to the Back Plane for testing only
SRU(SPORT3_DB_O,DAI_PB13_I); // connect the SPORT3_DB to the DAI pin buffer 13 input signal  
SRU(HIGH,PBEN13_I);		 // configures DAI pin13 as an output
SRU(SPORT3_DA_O,DAI_PB14_I); // connect the SPORT3_DA to the DAI pin buffer 14 input signal  
SRU(HIGH,PBEN14_I);		 // configures DAI pin14 as an output
SRU(SPORT3_CLK_O,DAI_PB15_I);// connect the SPORT3_CLK to the DAI pin buffer 15 input signal  
SRU(HIGH,PBEN15_I);		 // configures DAI pin15 as an output
SRU(SPORT3_FS_O,DAI_PB16_I); // connect the SPORT3_FS to the DAI pin buffer 16 input signal  
SRU(HIGH,PBEN16_I);		 // configures DAI pin16 as an output

// SPORT4 is a transmitter to the Back Plane
SRU(SPORT4_FS_O,DAI_PB17_I); // connect the SPORT4_FS to the DAI pin buffer 17 input signal  
SRU(HIGH,PBEN17_I);		 // configures DAI pin17 as an output
SRU(SPORT4_CLK_O,DAI_PB18_I);// connect the SPORT4_CLK to the DAI pin buffer 18 input signal  
SRU(HIGH,PBEN18_I);		 // configures DAI pin18 as an output
SRU(SPORT4_DB_O,DAI_PB19_I); // connect the SPORT4_DB to the DAI pin buffer 19 input signal  
SRU(HIGH,PBEN19_I);		 // configures DAI pin19 as an output
SRU(SPORT4_DA_O,DAI_PB20_I); // connect the SPORT4_DA to the DAI pin buffer 20 input signal  
SRU(HIGH,PBEN20_I);		 // configures DAI pin20 as an output

	}//initDAI.end

