///////////////////////////////////////////////////////////////////////////////////////
//NAME:     MFC Rev3 Board Test Configuration
//DATE:     08-04-09
//PURPOSE:  Configure the clockchip and ADC , SDRAM Test and Flash Test
//
////////////////////////////////////////////////////////////////////////////////////////
#include <def21369.h>
#include "cogging.h"

.global IRQ0_Service_Routine, Data_Acquire;

.section/pm seg_pm_jmp_tbl;
.VAR addressTable = TestRoutine; 	   // vector interrupt routine addresses (Starts at 0xC0000)
.VAR entry1 = SPI_Write;
.VAR entry2 = SPI_Read;
.VAR entry3 = FPGA_Data_Acquire;
.VAR entry4 = nullRoutine;
.VAR entry5 = nullRoutine;
.VAR entry6 = nullRoutine;
.VAR entry7 = nullRoutine;
.VAR entry8 = nullRoutine;
.VAR entry9 = nullRoutine;
.VAR entryA = nullRoutine;
.VAR entryB = nullRoutine;
.VAR entryC = nullRoutine;
.VAR entryD = nullRoutine;
.VAR entryE = nullRoutine;
.VAR entryF = nullRoutine;
.VAR entry10 = nullRoutine;
.VAR entry11 = nullRoutine;
.VAR entry12 = nullRoutine;
.VAR entry13 = nullRoutine;
.VAR entry14 = nullRoutine;
.VAR entry15 = nullRoutine;
.VAR entry16 = nullRoutine; 
.VAR entry17 = nullRoutine;
.VAR entry18 = nullRoutine;
.VAR entry19 = nullRoutine;
.VAR entry1A = nullRoutine;

.section/pm seg_pmco;

IRQ0_Service_Routine:
// Branch to interrupt by reading IRQ_MUX0,1,2 (FLAG 4,5,6)
// 101 - Interrupt 5 : DSP Bus Master  - Enable external port	
// 100 - Interrupt 4 : VXI Write interrupt service
// 011 - Interrupt 3 : Max2 Bus Master - Disable external port
// 010 - Interrupt 2 : VXI Read interrupt service
// 001 - Interrupt 1 : Vector interrupt service


	bit tst FLAGS FLG6|FLG4;  	// [f6, f5, f4] = 5 or 7
	if tf jump DSP_BM;  		

	bit tst FLAGS FLG5|FLG4;	// [f6, f5, f4] = 3
	if tf jump Max2_BM;

	bit tst FLAGS FLG4;			// [f6, f5, f4] = 1
	if tf jump VIRPT_Service;
	
	bit tst FLAGS FLG5;			// [f6, f5, f4] = 2 or 6
	if tf jump DSP_Read;		// VXI wants to read SDRAM through the MAX II and DSP
	
	bit tst FLAGS FLG6;			// [f6, f5, f4] = 4
	if tf jump DSP_Write;       // VXI wants to write SDRAM through the MAX II and DSP
	
	rti;  // else just return
	IRQ0_Service_Routine.end:

DSP_BM:						// Make DSP Bus master

    ustat3 = dm(SDCTL);
    bit clr ustat3 DSDCTL;	//Enables SDRAM controller    
    dm(SDCTL) = ustat3;
 
    ustat3 = dm(AMICTL1);
    bit set ustat3 AMIEN;	//Enables Flash Access
    dm(AMICTL1) = ustat3; 
       
    ustat3 = dm(AMICTL2);
    bit set ustat3 AMIEN;	//Enables Max2 Access    
    dm(AMICTL2) = ustat3;
        
    ustat3 = dm(AMICTL3);
    bit set ustat3 AMIEN;	//Enables FPGA Access    
    dm(AMICTL3) = ustat3;

    bit set FLAGS FLG10;	//FLG10 = 1 ,DSP is Bus Master     
    rti;    
        
DSP_BM.END:

Max2_BM:					//Make Max2 Bus Master

    ustat3 = dm(SDCTL);
    bit set ustat3 DSDCTL;	//Disables SDRAM controller
    dm(SDCTL) = ustat3;
    
    ustat3 = dm(AMICTL1);
    bit clr ustat3 AMIEN;	//Disables Flash Access
    dm(AMICTL1) = ustat3;
        
    ustat3 = dm(AMICTL2);
    bit clr ustat3 AMIEN;	//Disables Max2 Access
    dm(AMICTL2) = ustat3;
        
    ustat3 = dm(AMICTL3);
    bit clr ustat3 AMIEN;	//Disables FPGA Access
    dm(AMICTL3) = ustat3;
    
    bit clr FLAGS FLG10;	//FLG10 = 0 ,DSP external port disabled, Max2 is Bus Master 
 //--------------------------------------------------------------------------------------
 // Modification to avoid returning from interrupt until
 // the DSP is reset to be the bus master.
 
 // First re-enable the INT0 interrupt
 	bit set mode1  NESTM;   // 	mode1 will be reset to original after rti
 	bit clr irptl  IRQ0I;   // clear latched occurances of INT0
	bit set imask  IRQ0I;   // unmask (enable if set, = 1) 
	bit set imaskp IRQ0I;   // unmask (enable if set, = 1)
   
    lcntr = 656, do bmlpend until lce;
	bit tst FLAGS FLG10; 			
	if tf jump bmlpdone; // If Flag 10 has been reset by DSP_BM we are done.
    nop; nop; nop;
bmlpend:     nop;   // If this is not interrupted within 8 microseconds 
					// we must do the DSP_BM task here, then leave.
    
    ustat3 = dm(SDCTL);
    bit clr ustat3 DSDCTL;	//Enables SDRAM controller    
    dm(SDCTL) = ustat3;
 
    ustat3 = dm(AMICTL1);
    bit set ustat3 AMIEN;	//Enables Flash Access
    dm(AMICTL1) = ustat3; 
       
    ustat3 = dm(AMICTL2);
    bit set ustat3 AMIEN;	//Enables Max2 Access    
    dm(AMICTL2) = ustat3;
        
    ustat3 = dm(AMICTL3);
    bit set ustat3 AMIEN;	//Enables FPGA Access    
    dm(AMICTL3) = ustat3;

    bit set FLAGS FLG10;	//FLG10 = 1 ,DSP is Bus Master     
    
bmlpdone:
 // end modification --------------------------------------------------------------------
    rti;        

Max2_BM.END:

// Calls the corresponding VIRPT routine
VIRPT_Service:
	i0 = VIRPT_REG;
	r1 = dm(m5,i0);		//Get Address  of VIRPT written by Slot0
	i8 = r1;			
	r1 = pm(i8,m13);	//Address contains a variable that is a function pointer for the VIRPT to be executed
	i8 = r1;
	call (m13,i8);      // invoke function
	r12 = 200; call AsmDelay;
	i0 = VIRPT_REG;
	r0 = 0;				// if succesful, function must write a 0 to MSG_REG0 or -1 if error
	dm(m5,i0) = r0;     // return code for routine completed
	ustat2 = dm(AMISTAT);
	bit tst ustat2 AMIS;
	if tf jump (pc,-2);
	rti;
VIRPT_Service.end:

// Routine to carryout Slot0 Read request from SDRAM

	DSP_Read:
		i0 = VXI_ADDRESS_REG;  	// The offset to the Address Reg and Data Reg are
		i1 = VXI_DATA_REG;		//   arbitrary.  The MAX II sequences the address out first
								//   on the local data bus and then releases the bus so that
								//   the DSP can write the requested data into its local data
								//	 in register.  The MAX II passes the data onto the VXI bus.
								
		r1 = dm(m5,i0);       // get address from the MAX II local data out register.

	dsp_read_1:
		ustat2 = dm(AMISTAT);
		bit tst ustat2 AMIS;    // wait for read of external memory to complete
		if tf jump (pc,dsp_read_1);
	
		call Addr_decode; 		// Place decoded address in i0
	
		r2 = dm(m5,i0);			// Read from memory at the decoded address
		dm(m5,i1) = r2;  		// Write result in max2 data register
	
	dsp_read_2:
		ustat2 = dm(AMISTAT);
		bit tst ustat2 AMIS;
		if tf jump (pc,dsp_read_2);
	
		rti;
DSP_Read.end:

// Routine to carryout Slot0 Write request to SDRAM

DSP_Write:
		i0 = VXI_ADDRESS_REG;	// The offset to the Address Reg and Data Reg are
		i1 = VXI_DATA_REG;		//   arbitrary.  The MAX II sequences the address out first
								//   on the local data bus and then once the DSP's first 
								//   read is complete the MAX II drives the data to be written
								//	 onto the bus.
								
		r1 = dm(m5,i0);			// get address from the MAX II local data out register.
		
	dsp_write_1:
		ustat2 = dm(AMISTAT);
		bit tst ustat2 AMIS;
		if tf jump (pc,dsp_write_1);
		
		r5 = dm(m5,i1);  		// Get data to be written from max2 local data out register.
		
		call Addr_decode;		// Place decoded address in i0
		
		dm(m5,i0) = r5;			// Write data to decoded address
		rti;
DSP_Write.end:




Addr_decode:				//Returns decoded address in i0

//r2 = FEXT r1 BY 2:24;		//Bit 25 to 2 represents the offset from the base address for 32-bit word addresses
r2 = r1;					//Extraction now done in MaxII

r3 = DSPMEM_UPPR_LMT;		//#define DSPMEM_UPPR_LMT = 0x100000 (0x400000 divided by 4)
comp(r2,r3);
if lt jump AccessDSPIntMem; //Check if DSP internal memory access

r3 = SDRAM_UPPR_LMT;		//#define SDRAM_UPPR_LMT  = 0x140000 (0x500000 divided by 4)		
comp(r2,r3);
if lt jump AccessSDRAM;		//Check if SDRAM access
i0 = r3;					//Address is outside range, so use upper address limit
rts;

AccessDSPIntMem:
//r4 = DSP_DM_BASE_ADDRESS;
//r4 = r4 + r2;
r4 = r2;
i0 = r4;					//Further decoding may be required
rts;

AccessSDRAM:
r3 = DSPMEM_UPPR_LMT;		//#define DSPMEM_UPPR_LMT = 0x100000 (0x400000 divided by 4)
r2 = r2- r3; 				// Subtract base address
							//Add SDRAM address offset 
r4 = SDRAM_BASE_ADDRESS;
r4 = r2 + r4;
i0 = r4;
rts;

Addr_decode.end:



nullRoutine:
r0 = 0;
dm(m6,i0) = r0;  			// Write a 0 to MSG_REG0
	rts;

TestRoutine:		
i0 = MSG_REG0;
r1 = dm(m5,i0);
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
i0 = MSG_REG1;
r2 = dm(m5,i0);
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
r3 = r1 + r2;
i0 = MSG_REG2;
dm(m5,i0) = r3;
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
r1 = m5;
i1 = MSG_REG0;
dm(m5,i1) = r1;
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
rts;

//Write to Clk_Chip or ADC1-4, Device_number 0 = Clk_Chip, 1 = ADC1, 2 = ADC2 
SPI_Read:			//						 			   3 = ADC3, 4 = ADC4	
i0 = MSG_REG0;		// MSGR0 = Device_number
r1 = dm(m5,i0);	
i0 = MSG_REG1;		// MSGR1 = Address to be read
r2 = dm(m5,i0);
//Decode which device
r3 = 0;
comp(r1,r3);
if eq jump Clk_Read;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc1_Read;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc2_Read;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc3_Read;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc4_Read;
r1 = m7;					//Device number incorrect, do not write, return -1 in Msgr0 for error
i0 = MSG_REG0;
dm(m5,i0) = r1;

rts;

// Choose corresponding Chip Select
Clk_Read:
ustat3 = DS2EN|DS1EN|DS0EN;	/*Ties SPI CS to SPIFlags (Clk_CS)*/
jump Read_data;
Adc1_Read:
ustat3 = DS2EN|DS1EN;		/*Ties SPI CS to SPIFlags (ADC1_CS)*/
jump Read_data;
Adc2_Read:
ustat3 = DS2EN|DS0EN;		/*Ties SPI CS to SPIFlags (ADC2_CS)*/
jump Read_data;
Adc3_Read:
ustat3 = DS2EN;				/*Ties SPI CS to SPIFlags (ADC3_CS)*/
jump Read_data;
Adc4_Read:
ustat3 = DS1EN|DS0EN;		/*Ties SPI CS to SPIFlags (ADC4_CS)*/

Read_data:
dm(SPIFLG) = ustat3;
r0 = 0xA000FFFF;
r4 = lshift r2 by 16;
r0 = r0 or r4;
dm(TXSPI) = r0;
ustat3 = dm(SPISTAT);
bit tst ustat3 TXS;     // Check to see if transmit complete (TXS =0)
if tf jump (pc,-2);
r12 = 10000; call AsmDelay;// Add additional delay 08-10-09, PV
r1 = dm(RXSPI);
r2 = FEXT r1 BY 0:16;
i0 = MSG_REG1;			// Place read result in Msgr1
dm(m5,i0) = r2;
r12 = 200; call AsmDelay;// Add additional delay 08-10-09, PV

r1 = m5;					//Conclude VIRPT by writing a 0 to Msrg0
i0 = MSG_REG0;
dm(m5,i0) = r1;
rts;

//Write to Clk_Chip or ADC1-4, Device_number 0 = Clk_Chip, 1 = ADC1, 2 = ADC2 
SPI_Write:			//						 			   3 = ADC3, 4 = ADC4	
i0 = MSG_REG0;		// MSGR0 = Device_number
r1 = dm(m5,i0);	
i0 = MSG_REG1;		// MSGR1 = Data to be written
r2 = dm(m5,i0);
//Decode which device
r3 = 0;
comp(r1,r3);
if eq jump Clk_Write;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc1_Write;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc2_Write;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc3_Write;
r3 = r3 + 1;
comp(r1,r3);
if eq jump Adc4_Write;
r1 = m7;					//Device number incorrect, do not write, return -1 in Msgr0 for error
i0 = MSG_REG0;
dm(m5,i0) = r1;

rts;

// Choose corresponding Chip Select
Clk_Write:
ustat3 = DS2EN|DS1EN|DS0EN;	/*Ties SPI CS to SPIFlags (Clk_CS)*/
r4 = 0x205A0100;
jump Write_data;
Adc1_Write:
ustat3 = DS2EN|DS1EN;		/*Ties SPI CS to SPIFlags (ADC1_CS)*/
r4 = 0x20FF0100;
jump Write_data;
Adc2_Write:
ustat3 = DS2EN|DS0EN;		/*Ties SPI CS to SPIFlags (ADC2_CS)*/
r4 = 0x20FF0100;
jump Write_data;
Adc3_Write:
ustat3 = DS2EN;				/*Ties SPI CS to SPIFlags (ADC3_CS)*/
r4 = 0x20FF0100;
jump Write_data;
Adc4_Write:
ustat3 = DS1EN|DS0EN;		/*Ties SPI CS to SPIFlags (ADC4_CS)*/
r4 = 0x20FF0100;
Write_data:
dm(SPIFLG) = ustat3;
dm(TXSPI) = r2;				//Write data to selected device
ustat3 = dm(SPISTAT);
bit tst ustat3 TXS;     	// Check to see if transmit complete (TXS =0)
if tf jump (pc,-2);
r12 = 20000; call AsmDelay;
dm(TXSPI) = r4;				//Write data to selected device
r12 = 20000; call AsmDelay;
r1 = m5;					//Conclude VIRPT by writing a 0 to Msrg0
i0 = MSG_REG0;
dm(m5,i0) = r1;
rts;	

//Initiates data aquisition of specified ADC_channel or all ADC_channels
//Calls Data_Aquire routine to transfer ADC data from FPGA to SDRAM   
FPGA_Data_Acquire:
i0 = MSG_REG0;				// MSGR0 = ADC_Channel number, 0 -31 -> 12bit ADC, channels 1-32
r2 = dm(m5,i0);				//							   32 	 -> 14bit ADC
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
							// r2 = channel number
bit set irptl SFT0I;		//latch software interrupt0 which calls the routine Data_Aquire that does
r12 = 20; call AsmDelay;							//the data aquisition in the background
r1 = m5;					//Conclude VIRPT by writing a 0 to Msrg0
i0 = MSG_REG0;
dm(m5,i0) = r1;
ustat2 = dm(AMISTAT);
bit tst ustat2 AMIS;
if tf jump (pc,-2);
rts;	
FPGA_Data_Acquire.END:

Data_Acquire:				//Routine to aquire single channel FPGA data
r2 = pass r2;				//channel number in r2
if lt jump Chan_Error;		//if r2 < 0  then error, do not aquire
r3 = 32;
r4 = 0x300;					//bit6 = 0, len6 = 12 for data extraction from 32-bit FPGA data
r5 = 0x380;					//bit6 = 0, len6 = 14 for data extraction from 32-bit FPGA data
comp(r2,r3);				//channel number in r2
if gt jump Chan_Error;		//if r2 > 32 - error, do not aquire
if eq r6 = r5;				//channel number = 32 , r6 = 0x380 for extracting 14-bit ADC data
if ne r6 = r4;				//channel number < 32 , r6 = 0x300 for extracting 12-bit ADC data
//r6 = 0x400;					//Test data from NCOtable, get full 16 bits
call Acquire_Channel; 		//Aquire data
Chan_Error:
pop sts;
nop;						//1 cycle delay
rti;
Data_Acquire.END:

  
Acquire_Channel:
//r2 = 1;					//channel to aquire in r2, SDRAM start address in r4
i2 = FPGA_DAQ_CTL;			//Write channel number to FPGA control register (address 0x1C800)
dm(m5,i2) = r2;
r12 = 20; call AsmDelay;
bit set FLAGS FLG7;			//FLG7 tied to DPI10 is positive edge trigger to FPGA to start aquiring data
r12 = 20; call AsmDelay;
bit clr FLAGS FLG7;			//clear trigger to FPGA

bit tst FLAGS FLG8;			//FLG8 tied to DPI11 is data aquisition status input from FPGA: 0 = complete
if tf jump (pc,-1);			//Wait here till aquisition complete
r12 = 20; call AsmDelay;
i2 = FPGA_DAQ_BASE_ADDR;	//Data aquisition complete, now transfer data to SDRAM
i3 = SDRAM_BASE_ADDRESS;	//Starting address of  data in SDRAM
m6 = 1;
//r6 = 0x400;				//Test data from counter, get full 16 bits
//r9 = 2;
lcntr = 1, do StoreAdcDataOuter until lce;
lcntr = 65535, do StoreAdcData until lce;
r7 = dm(i2,m6);				//Get 32-bit FPGA data.  r6 = 0x300 for 12-bit channels and 0x380 for 14-bit channel
//r8 = FDEP r7 by r6 (se);	//Extract appropriate bit field based on channel number

r8 = FDEP r7 by r6 (se);	//Extract 16 LSB's only since the data word size is 16 bits
//r8 = r9 - r8;
dm(i3,m6) = r8;				//Store in SDRAM
//r9 =r9 + 1;
//nop; nop; nop;
//nop; nop; nop;
//nop; nop; nop;
StoreAdcData:
nop; nop; nop;
StoreAdcDataOuter:
nop;
rts; 
Acquire_Channel.END:

// Variable Delay - counter value must be placed in r12 
AsmDelay:
	lcntr = r12, do delay_loop until lce;
	nop;
	nop;
delay_loop:
	nop;
	nop;
	rts;
