///////////////////////////////////////////////////////////////////////////////////////
//NAME:     MFC Rev3 Board Test Configuration
//DATE:     08-04-09
//PURPOSE:  Configure the clockchip and ADC , SDRAM Test
//
////////////////////////////////////////////////////////////////////////////////////////
#include <Cdef21369.h>
#include <def21369.h>
#include <21369.h>
#include <sru21369.h>
#include <sysreg.h>
#include <signal.h>          // for interrupt
//#include <string.h>
//#include <stdio.h>

// The following definition allows the SRU macro to check for errors. Once the routings have
// been verified, this definition can be removed to save some program memory space.
// The preprocessor will issue a warning stating this when using the SRU macro without this
// definition
#define SRUDEBUG  // Check SRU Routings for errors.
#include <SRU.h>


// local project header files
#include "cogging.h"              // for #defines
#include "mfctest_c.h"            // for C prototypes
#include "param_mem.h"            // parameter memory management
#include "Flash_Store_Process.h"

/* =============================================================================== */
/* Define and Declare the Parameter Structures Below  (see param_mem.h)            */
/* Initialize the structure elements below.                                        */

	struct dm_int_params iparams[NINTPARAMS] =
	{
				            //{dimension  | L. L. | U. L.| Dflt |       <pointers >         | }
				            //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/* 0. Param 0 (reserved)    */ {1         , -32767, 32767,   1  , 0, 0, 0, (int*) P0_OFFSET   },
/* 1. Param 1 (reserved)    */ {1         , -32767, 32767,   2  , 0, 0, 0, (int*) P1_OFFSET   },
/* 2. Param 2 (reserved)    */ {1         , -32767, 32767,   4  , 0, 0, 0, (int*) P2_OFFSET   },
/* 3. Param 3 (reserved)    */ {1         , -32767, 32767,   8  , 0, 0, 0, (int*) P3_OFFSET   },
/* 4. Param 4 (reserved)    */ {1         , -32767, 32767,  16  , 0, 0, 0, (int*) P4_OFFSET   },
/* 5. Param 5 (reserved)    */ {1         , -32767, 32767,  32	, 0, 0, 0, (int*) P5_OFFSET   },
/* 6. Param 6 (reserved)    */ {1         , -32767, 32767,  64  , 0, 0, 0, (int*) P6_OFFSET   },
/* 7. Param 7 (reserved)    */ {1         , -32767, 32767, 128  , 0, 0, 0, (int*) P7_OFFSET   },
/* 8. Param 8 (reserved)    */ {14        , -32767, 32767, 2989 , 0, 0, 0, (int*) P8_OFFSET   }
	};							

	
	#define PARAM_0_DESCR "0. TODO: Setup descriptive text for param 0 in cogging.h\n"
	#define PARAM_1_DESCR "1. TODO: Setup descriptive text for param 1 in cogging.h\n"
	#define PARAM_2_DESCR "2. TODO: Setup descriptive text for param 2 in cogging.h\n"
	#define PARAM_3_DESCR "3. TODO: Setup descriptive text for param 3 in cogging.h\n"
	#define PARAM_4_DESCR "4. TODO: Setup descriptive text for param 4 in cogging.h\n"
	#define PARAM_5_DESCR "5. TODO: Setup descriptive text for param 5 in cogging.h\n"
	#define PARAM_6_DESCR "6. TODO: Setup descriptive text for param 6 in cogging.h\n"
	#define PARAM_7_DESCR "7. TODO: Setup descriptive text for param 7 in cogging.h\n"
	#define PARAM_8_DESCR "8. TODO: Setup descriptive text for param 8 in cogging.h\n"
	
		
/*--------------------------------------------------------------------------------------*/			
	float ftemp;
	struct dm_flt_params fparams[NFLTPARAMS] =
	{
				            //{dimension| Lower Lim| Upper Lim| Default Val|<pointers >}
				            //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/* 0. Undefined float param */{1        , 0.       , 1.       , 1.         , 0, 0, 0, &ftemp}
	}; 	


/* ======= Global Variables In Heap ==================== */
	int cyc_active;
	int flash_active;
	int request_store=0;
	
/* ===================================================== */
// Declare pointers to the Variable registers in the SDRAM
	int *pCommandReg;

/* ===================================================== */
// Declare pointers to the Variable registers in the FPGA
	int command = 1;
	int *pPulseTest;
		

main()
	
{
	int test_result = 0;
		
//Disable Global Interrupts
	asm("bit clr mode1 IRPTEN;");

	initMFCBoard();
//	init_ASM();      // moved call of this to initMFCBoard()
//	init_ASM_Stack();// moved call of this to initMFCBoard()  
	
// Initialize the AD9510 Clock Distribution chip and the AD9222 ADCs 
    init_SPI_Devices();
	SPI_Write_IC(0,0x20582180);	// (58) Func Pin: Enable Sync Detect for status pin <0>
	 								// Synchronizes the phase of all outputs
	Delay(20000);					// Additional delay	 		    								
	SPI_Write_IC(0,0x205A0100);	// Transfer buffer data to control registers
					   							// Address 0x59 not used	 			 		
					   							
//  Setup pointers to FPGA and SDRAM registers
	pPulseTest  = (int *) TEST_POINT_1;
	pCommandReg	= (int *) (CNTRL_REG_BASE + 1); // a register in SDRAM
		*pCommandReg = (int) 0;
			
//  Initialize Flash ----------------------	
	Init_Flash_Process((int) FLASH_BASE_ADDRESS, (int) FLASH_SECTOR_SIZE);
	reset_flash();
	flash_active = 0;
	
//  Initialize memory pointer to parameter structure
	prm = (struct parameter_mem *)PARAM_MEM_BASE;	// see cogging.h (0x00230000)			   							
	setup_params();	
					   							
//  Setup Message Buffer -------------
	prm->nChar = 0; // start at the beginning of the buffer

//  Restore non-volatile parameters --
	restoreparams();
	updateparams();	
					   							
//  Setup the Start of Cycle Interrupt on IRQ1
// 				say: interrupt (SIG_IRQ1, SIG_IGN); to disable interrupt
 	interruptfnsm(SIG_IRQ1, StartCycleIntrpt); 
   	interruptfnsm(SIG_TMZ0, CycleTimerIntrpt);

	asm("bit clr FLAGS FLG9;");		//Signal Max2 (DSP-MAX2 Spare0) that DSP is running 
	pause(0xA0000); // pause 8 milliseconds ?
	
//#################### FPGA is Assumed to be Ready Now ############################	

	sprintf(msg_str,"Initialization Complete\n");message2(msg_str);
//#################### Begin Low Priority Polling #################################
	while(1)
	{	
		idle();
/*		asm("bit clr imask IRQ0I;");
		test_result = sysreg_bit_tst(sysreg_FLAGS, FLG10);
		if (test_result != 0) // that is DSP is bus master, then
		{
 			*pPulseTest = 1;
		}
		asm("bit set imask IRQ0I;");
			
		pause(0xA);
		
				*pPulseTest = 1;
		{ }
		
		flash_active = Flash_Store_Process((int*) &request_store);
*/		
/*		if(*pCommandReg > 0) 
		{
			
			if (flash_active != 1)
			{
				request_store = 1;
				sprintf(msg_str,"got request_store, Reg = %ld\n", *pCommandReg);message2(msg_str);
				*pCommandReg = 0;
			}
		}
	
*/		
		//----------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------
		
	}	
	
//wait:   idle();
//	goto wait;
	
	
	
	} //main.end

/*******************************************************************************************/
// 
#define CYCLEDURATION 0x00B42D00  // 11,808,000 clocks = 36 ms.
						   //Number of 328MHz clocks between interrupts.  The Timer ISR must 
						   // perform certain tasks on a regular basis.  A runinng sum of the
						   // number of clocks since the beginning of the cycle is kept. The sum
						   // is compared to scheduled event times (counts).  .

void StartCycleIntrpt(int dummy)  // IRQ1
{
	//Start the Cycle Timer
	cyc_active = 1;
		 	
	timer_set( CYCLEDURATION, CYCLEDURATION);
	timer_on();
	
	
//	*pPulseTest = command; // pulse test point out
		
	return;	
}

void CycleTimerIntrpt(int dummy)   // Timer Interrupt (high priority version)
{
	int i;
	
	cyc_active = 0;	
	timer_off();
	
	updateparams(); 
	
	//request_store = 1; // Parameter Storage is Requested
										
	// NOTE: FPGA Timer stops on its own and is reset by IRQ1
	
	return;
}

/*************************************************************************/
// Parameter Management Routines



/*========================================================================== */
// setup_params(void)
//
// This routine establishes the parameter settings for the application.
// It sets up values for the parameter structure and parameter memory

int setup_params(void)
{
	int OFFSET_1, offset, flash_ndx;
	int j;
	
	offset = 1;
	flash_ndx = 0;
		
	prm->nint_params = (int) NINTPARAMS;
	prm->nflt_params = (int) NFLTPARAMS;
	
	// Compute the offset between the PARAM_MARKER and DATA_MARKER
	OFFSET_1 = &prm->DATA_MARKER - &prm->PARAM_MARKER;
	
	// The ip[].rdg and ip[].set variables will be the offset from the 
	// PARAM_MARKER and the shared memory location storing the parameters
	// reading and setting, respectively.  That is the offset to the first
	// value if the dimension of the parameter is more than one.
	
	
	for (j=0; j<NINTPARAMS; j++)
	{
		prm->ip[j].dim = iparams[j].dim ;  // this is the parameter dimension.
		prm->ip[j].ul  = iparams[j].ul  ;  // upper limit of value
		prm->ip[j].ll  = iparams[j].ll  ;  // lower limit of value
		prm->ip[j].dflt= iparams[j].dflt;  // default value
		prm->ip[j].flag= 0;		          // update flag
		
		//---------------------------------------------------------------------
		// prm->ip[j].rdg is a memory offset from the prm->PARAM_MARKER address
		// likewise for prm->ip[j].set.
		//---------------------------------------------------------------------
		prm->ip[j].rdg = OFFSET_1 + offset; // pointer to reading (marker + 1)
		offset += prm->ip[j].dim;
		
		prm->ip[j].set = OFFSET_1 + offset; // pointer to setting (marker + 2)
		offset += prm->ip[j].dim;
		
		iparams[j].sm_rdg = (int *) (prm->ip[j].rdg + &prm->PARAM_MARKER);
		iparams[j].sm_set = (int *) (prm->ip[j].set + &prm->PARAM_MARKER); 
		
		//----------------------------------------------------------------------------
		// Only the parameter and curve values are stored in the Flash memory.
		// The upper and lower limits and default values are not adjustable and
		// are setup by the initial values in the iparams structures in "param_mem.h".
		//
		// NOTE THE VALUE OF flsh_val IS ONLY AN OFFSET.  YOU MUST ALSO ADD 
		// (sector_ndx * FLASH_SECTOR_SIZE) WHEN YOU WISH TO ACCESS THE VALUE IN FLASH.
		// THE sector_ndx MIGHT CHANGE DYNAMICALLY IN LATER VERSIONS.
		//----------------------------------------------------------------------------
		iparams[j].flsh_val = (int *) FLASH_BASE_ADDRESS + flash_ndx*4;  /*ptr to the Flash memory storage*/
		flash_ndx += iparams[j].dim;
		
		// Note that the iparams[].param pointer is setup in "param_mem.h".
		
	}

	// Parameter Description for shared memory`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~
		strcpy(prm->ip[0].desc , PARAM_0_DESCR);
		strcpy(prm->ip[1].desc , PARAM_1_DESCR);
		strcpy(prm->ip[2].desc , PARAM_2_DESCR);
		strcpy(prm->ip[3].desc , PARAM_3_DESCR);
		strcpy(prm->ip[4].desc , PARAM_4_DESCR);
		strcpy(prm->ip[5].desc , PARAM_5_DESCR);
		strcpy(prm->ip[6].desc , PARAM_6_DESCR);
		strcpy(prm->ip[7].desc , PARAM_7_DESCR);
		strcpy(prm->ip[8].desc , PARAM_8_DESCR);
	
	// Setup float type parameters ~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`~`
	for (j=0; j<NFLTPARAMS; j++)
	{
		prm->fp[j].dim = fparams[j].dim ;  // this is the parameter dimension.
		prm->fp[j].ul  = fparams[j].ul  ;  // upper limit of value
		prm->fp[j].ll  = fparams[j].ll  ;  // lower limit of value
		prm->fp[j].dflt= fparams[j].dflt;  // default value
		prm->fp[j].flag= 0;		          // update flag
		
		prm->fp[j].rdg = OFFSET_1 + offset; // pointer to reading (marker + 1)
		offset += prm->fp[j].dim;			// "offset" has not been reset since incrementing it above
		
		prm->fp[j].set = OFFSET_1 + offset; // pointer to setting (marker + 2)
		offset += prm->fp[j].dim;
		
		fparams[j].sm_rdg = (float *) (prm->fp[j].rdg + &prm->PARAM_MARKER);
		fparams[j].sm_set = (float *) (prm->fp[j].set + &prm->PARAM_MARKER); 
		
		fparams[j].flsh_val = (float *) FLASH_BASE_ADDRESS + flash_ndx*4;  /*ptr to the Flash memory storage*/
		flash_ndx += fparams[j].dim;
		
		// Note that the fparams[].params pointer is setup in the declaration or elswhere.
		
	}
	
	// Prototype float value 
	strcpy(prm->fp[0].desc, "F0. Prototype float value\n");
	
	// Set a known value in DATA_MARKER
	prm->DATA_MARKER = 0x0A5A5A5A;  // it was the address of the MARKERs that was used above
	prm->PARAM_MARKER = 0x0FEDCBA9; // these values help me find the MARKERs when looking 
								   // through a memory dump.
								   
	// MMMMMMMMMMMMMM  Initialize Flash Update Flag   MMMMMMMMMMMMMMMMM	//						   
	update_flash_flag = 0;
	
	return 0;
}

//--------------------------------------------------------------------------------------------
//	Restore parameters from nonvolatile memory at program startup

int restoreparams(void)
{

	int j,k;
	
	float fval;
	int   ival;
		
	for (j=0; j<NINTPARAMS ;j++)
	{
		for (k=0;k < iparams[j].dim; k++)
		{
			// Read the value stored in the Flash memory
			flash_read_param((void *)(iparams[j].flsh_val + k), (void *) &ival);
			
			// Test the value read from the Flash memory
			if ( ival > iparams[j].ul || ival < iparams[j].ll)
			{
				ival = iparams[j].dflt;
			}
			*(iparams[j].sm_set + k) = ival; // Write the parameter setting
		}
		prm->ip[j].flag = 1;
	}

		
	for (j=0; j<NFLTPARAMS ;j++)
	{
		for (k=0;k < fparams[j].dim; k++)
		{
			flash_read_param((int *)(fparams[j].flsh_val + k), (int *) &fval);
			if ( fval > fparams[j].ul || fval < fparams[j].ll)
			{
				fval = fparams[j].dflt;
			}
			*(fparams[j].sm_set + k) = fval; // Write the sm setting
			// *(fparams[j].param + k) = fval; // Write the local parameter <-- do with updateparams()
		}
		prm->fp[j].flag = 1;
	}
	
		
	return 0;
}

// --------------

//	Read and check new parameters at 15Hz; use if within limits, otherwise don't change
//  *** NOTE *** Bits are shifted up into LD(31..16) for local parameter. This is good
//               for those parameters written into the FPGA's but a bit of a pain for
//               those that remain as local DSP data memory variables.
int updateparams(void)
{
	int   j,k;
	float fval;
	int   ival;
			
	for (j=0; j<NINTPARAMS ;j++)
	{
		if ( prm->ip[j].flag > 0 )
		{
//sprintf(msg_str,"found a setip()\n");message2(msg_str);
			
			for (k=0; k < iparams[j].dim; k++)
			{
				ival = *(iparams[j].sm_set + k);
//sprintf(msg_str,"setting = %d\n", ival);message2(msg_str);
		
			  	if( ival <= iparams[j].ul && ival >= iparams[j].ll ) //if in bounds then ...
			  	{			  				
					*(iparams[j].param + k)  = ival; 
					*(iparams[j].sm_rdg + k) = ival; // Set the parameter reading
					update_flash_flag = 1;
			  	}
			}
			prm->ip[j].flag = 0;
		}
	}
	
	for (j=0; j<NFLTPARAMS ;j++)
	{
		if ( prm->fp[j].flag > 0 )
		{
			for (k=0; k < fparams[j].dim; k++)
			{
				fval = *(fparams[j].sm_set + k);
		
			  	if( fval <= fparams[j].ul && fval >= fparams[j].ll )
			  	{			  				
					*(fparams[j].param + k)  = fval;  // Set the local parameter
					*(fparams[j].sm_rdg + k) = fval; // Set the sm reading
					update_flash_flag = 1;
			  	}
			}
			prm->fp[j].flag = 0;
		}
	}
	
	return 0;
}

//===================================================================
 // message2(char *msg) -- writes strings into the message buffer in
 //                       shared memory.
 
 int message2(char *msg)
 {
 	int i, cnt, len;
 	
 	prm->msgsem = 1;  //  <--- Still need to check for availability of semaphore
 	cnt = prm->nChar;
 	len = strlen(msg);
 	
 	i=0;
 	while(i<len && cnt < MAXMSGLEN)
 	{
 		prm->msg[cnt] = *(msg+i);
 		i++; cnt++;
 	}
 	
 	if(cnt < MAXMSGLEN) {prm->msg[cnt]= 0; cnt++;}
 	prm->nChar = cnt; 
 	prm->msgsem = 0;
 	
 	if(cnt > MAXMSGLEN) prm->nChar = MAXMSGLEN;
 	return 0;	
 }

 //==================================================================
 // PAUSE Loop
 
 int pause(int counts)
 {
 	int i;
 	for(i=0;i<counts;i++) asm("nop;");
 	return 0;	
 }

 
 //=================================================================
